diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/comment.php ./wordpress-3.4/wp-admin/comment.php
*** ./wordpress-3.3.2/wp-admin/comment.php	2011-11-30 20:22:07.000000000 -0600
--- ./wordpress-3.4/wp-admin/comment.php	2012-02-07 13:13:30.000000000 -0600
***************
*** 65,71 ****
  	$comment_id = absint( $_GET['c'] );
  
  	if ( !$comment = get_comment( $comment_id ) )
! 		comment_footer_die( __('Oops, no comment with this ID.') . sprintf(' <a href="%s">'.__('Go back').'</a>!', 'javascript:history.go(-1)') );
  
  	if ( !current_user_can( 'edit_comment', $comment_id ) )
  		comment_footer_die( __('You are not allowed to edit this comment.') );
--- 65,71 ----
  	$comment_id = absint( $_GET['c'] );
  
  	if ( !$comment = get_comment( $comment_id ) )
! 		comment_footer_die( __('Oops, no comment with this ID.') . sprintf(' <a href="%s">' . __('Go back') . '</a>.', 'javascript:history.go(-1)') );
  
  	if ( !current_user_can( 'edit_comment', $comment_id ) )
  		comment_footer_die( __('You are not allowed to edit this comment.') );
***************
*** 73,81 ****
  	if ( 'trash' == $comment->comment_approved )
  		comment_footer_die( __('This comment is in the Trash. Please move it out of the Trash if you want to edit it.') );
  
- 	if ( 'spam' == $comment->comment_approved )
- 		comment_footer_die( __('This comment is marked as Spam. Please mark it as Not Spam if you want to edit it.') );
- 
  	$comment = get_comment_to_edit( $comment_id );
  
  	include('./edit-form-comment.php');
--- 73,78 ----
***************
*** 222,228 ****
  	$noredir = isset($_REQUEST['noredir']);
  
  	if ( !$comment = get_comment($comment_id) )
! 		comment_footer_die( __('Oops, no comment with this ID.') . sprintf(' <a href="%s">'.__('Go back').'</a>!', 'edit-comments.php') );
  	if ( !current_user_can( 'edit_comment', $comment->comment_ID ) )
  		comment_footer_die( __('You are not allowed to edit comments on this post.') );
  
--- 219,225 ----
  	$noredir = isset($_REQUEST['noredir']);
  
  	if ( !$comment = get_comment($comment_id) )
! 		comment_footer_die( __('Oops, no comment with this ID.') . sprintf(' <a href="%s">' . __('Go back') . '</a>.', 'edit-comments.php') );
  	if ( !current_user_can( 'edit_comment', $comment->comment_ID ) )
  		comment_footer_die( __('You are not allowed to edit comments on this post.') );
  
***************
*** 295,299 ****
  } // end switch
  
  include('./admin-footer.php');
- 
- ?>
--- 292,294 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/credits.php ./wordpress-3.4/wp-admin/credits.php
*** ./wordpress-3.3.2/wp-admin/credits.php	2011-12-08 10:55:55.000000000 -0600
--- ./wordpress-3.4/wp-admin/credits.php	2012-06-07 10:34:21.000000000 -0500
***************
*** 17,23 ****
  
  	$results = get_site_transient( 'wordpress_credits_' . $locale );
  
! 	if ( ! is_array( $results ) ) {
  		$response = wp_remote_get( "http://api.wordpress.org/core/credits/1.0/?version=$wp_version&locale=$locale" );
  
  		if ( is_wp_error( $response ) || 200 != wp_remote_retrieve_response_code( $response ) )
--- 17,25 ----
  
  	$results = get_site_transient( 'wordpress_credits_' . $locale );
  
! 	if ( ! is_array( $results )
! 		|| ( isset( $results['data']['version'] ) && strpos( $wp_version, $results['data']['version'] ) !== 0 )
! 	) {
  		$response = wp_remote_get( "http://api.wordpress.org/core/credits/1.0/?version=$wp_version&locale=$locale" );
  
  		if ( is_wp_error( $response ) || 200 != wp_remote_retrieve_response_code( $response ) )
***************
*** 44,56 ****
  
  list( $display_version ) = explode( '-', $wp_version );
  
! include( './admin-header.php' );
  ?>
  <div class="wrap about-wrap">
  
  <h1><?php printf( __( 'Welcome to WordPress %s' ), $display_version ); ?></h1>
  
! <div class="about-text"><?php printf( __( 'Thank you for updating to the latest version! Using WordPress %s will improve your looks, personality, and web publishing experience. Okay, just the last one, but still. :)' ), $display_version ); ?></div>
  
  <div class="wp-badge"><?php printf( __( 'Version %s' ), $display_version ); ?></div>
  
--- 46,58 ----
  
  list( $display_version ) = explode( '-', $wp_version );
  
! include( ABSPATH . 'wp-admin/admin-header.php' );
  ?>
  <div class="wrap about-wrap">
  
  <h1><?php printf( __( 'Welcome to WordPress %s' ), $display_version ); ?></h1>
  
! <div class="about-text"><?php printf( __( 'Thank you for updating to the latest version! WordPress %s is already making your website better, faster, and more attractive, just like you!' ), $display_version ); ?></div>
  
  <div class="wp-badge"><?php printf( __( 'Version %s' ), $display_version ); ?></div>
  
***************
*** 73,79 ****
  		'http://wordpress.org/about/',
  		/* translators: Url to the codex documentation on contributing to WordPress used on the credits page */
  		__( 'http://codex.wordpress.org/Contributing_to_WordPress' ) ) . '</p>';
! 	include( './admin-footer.php' );
  	exit;
  }
  
--- 75,81 ----
  		'http://wordpress.org/about/',
  		/* translators: Url to the codex documentation on contributing to WordPress used on the credits page */
  		__( 'http://codex.wordpress.org/Contributing_to_WordPress' ) ) . '</p>';
! 	include( ABSPATH . 'wp-admin/admin-footer.php' );
  	exit;
  }
  
***************
*** 134,140 ****
  </div>
  <?php
  
! include( './admin-footer.php' );
  
  return;
  
--- 136,142 ----
  </div>
  <?php
  
! include( ABSPATH . 'wp-admin/admin-footer.php' );
  
  return;
  
***************
*** 157,161 ****
  __( 'Internationalization' );
  __( 'External Libraries' );
  __( 'Icon Design' );
- 
- ?>
--- 159,161 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/custom-background.php ./wordpress-3.4/wp-admin/custom-background.php
*** ./wordpress-3.3.2/wp-admin/custom-background.php	2011-12-01 22:31:01.000000000 -0600
--- ./wordpress-3.4/wp-admin/custom-background.php	2012-06-12 14:27:41.000000000 -0500
***************
*** 53,58 ****
--- 53,61 ----
  	function __construct($admin_header_callback = '', $admin_image_div_callback = '') {
  		$this->admin_header_callback = $admin_header_callback;
  		$this->admin_image_div_callback = $admin_image_div_callback;
+ 
+ 		add_action( 'admin_menu', array( $this, 'init' ) );
+ 		add_action( 'wp_ajax_set-background-image', array( $this, 'wp_set_background_image' ) );
  	}
  
  	/**
***************
*** 70,75 ****
--- 73,84 ----
  		add_action("load-$page", array(&$this, 'take_action'), 49);
  		add_action("load-$page", array(&$this, 'handle_upload'), 49);
  
+ 		if ( isset( $_REQUEST['context'] ) && $_REQUEST['context'] == 'custom-background' ) {
+ 			add_filter( 'attachment_fields_to_edit', array( $this, 'attachment_fields_to_edit' ), 10, 2 );
+ 			add_filter( 'media_upload_tabs', array( $this, 'filter_upload_tabs' ) );
+ 			add_filter( 'media_upload_mime_type_links', '__return_empty_array' );
+ 		}
+ 
  		if ( $this->admin_header_callback )
  			add_action("admin_head-$page", $this->admin_header_callback, 51);
  	}
***************
*** 96,101 ****
--- 105,112 ----
  			'<p>' . __( '<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>' ) . '</p>'
  		);
  
+ 		add_thickbox();
+ 		wp_enqueue_script('media-upload');
  		wp_enqueue_script('custom-background');
  		wp_enqueue_style('farbtastic');
  	}
***************
*** 124,129 ****
--- 135,141 ----
  			set_theme_mod('background_image', '');
  			set_theme_mod('background_image_thumb', '');
  			$this->updated = true;
+ 			wp_safe_redirect( $_POST['_wp_http_referer'] );
  			return;
  		}
  
***************
*** 199,213 ****
  
  if ( get_background_image() ) {
  	// background-image URL must be single quote, see below
! 	$background_styles .= ' background-image: url(\'' . get_theme_mod('background_image_thumb', '') . '\');'
  		. ' background-repeat: ' . get_theme_mod('background_repeat', 'repeat') . ';'
  		. ' background-position: top ' . get_theme_mod('background_position_x', 'left');
  }
  ?>
  <div id="custom-background-image" style="<?php echo $background_styles; ?>"><?php // must be double quote, see above ?>
  <?php if ( get_background_image() ) { ?>
! <img class="custom-background-image" src="<?php echo get_theme_mod('background_image_thumb', ''); ?>" style="visibility:hidden;" alt="" /><br />
! <img class="custom-background-image" src="<?php echo get_theme_mod('background_image_thumb', ''); ?>" style="visibility:hidden;" alt="" />
  <?php } ?>
  </div>
  <?php } ?>
--- 211,225 ----
  
  if ( get_background_image() ) {
  	// background-image URL must be single quote, see below
! 	$background_styles .= ' background-image: url(\'' . set_url_scheme( get_theme_mod( 'background_image_thumb', get_background_image() ) ) . '\');'
  		. ' background-repeat: ' . get_theme_mod('background_repeat', 'repeat') . ';'
  		. ' background-position: top ' . get_theme_mod('background_position_x', 'left');
  }
  ?>
  <div id="custom-background-image" style="<?php echo $background_styles; ?>"><?php // must be double quote, see above ?>
  <?php if ( get_background_image() ) { ?>
! <img class="custom-background-image" src="<?php echo set_url_scheme( get_theme_mod( 'background_image_thumb', get_background_image() ) ); ?>" style="visibility:hidden;" alt="" /><br />
! <img class="custom-background-image" src="<?php echo set_url_scheme( get_theme_mod( 'background_image_thumb', get_background_image() ) ); ?>" style="visibility:hidden;" alt="" />
  <?php } ?>
  </div>
  <?php } ?>
***************
*** 226,232 ****
  </tr>
  <?php endif; ?>
  
! <?php if ( defined( 'BACKGROUND_IMAGE' ) ) : // Show only if a default background image exists ?>
  <tr valign="top">
  <th scope="row"><?php _e('Restore Original Image'); ?></th>
  <td>
--- 238,245 ----
  </tr>
  <?php endif; ?>
  
! <?php $default_image = get_theme_support( 'custom-background', 'default-image' ); ?>
! <?php if ( $default_image && get_background_image() != $default_image ) : ?>
  <tr valign="top">
  <th scope="row"><?php _e('Restore Original Image'); ?></th>
  <td>
***************
*** 240,252 ****
  
  <?php endif; ?>
  <tr valign="top">
! <th scope="row"><?php _e('Upload Image'); ?></th>
  <td><form enctype="multipart/form-data" id="upload-form" method="post" action="">
! <label for="upload"><?php _e('Choose an image from your computer:'); ?></label><br /><input type="file" id="upload" name="import" />
! <input type="hidden" name="action" value="save" />
! <?php wp_nonce_field('custom-background-upload', '_wpnonce-custom-background-upload') ?>
! <?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
! </form>
  </td>
  </tr>
  </tbody>
--- 253,277 ----
  
  <?php endif; ?>
  <tr valign="top">
! <th scope="row"><?php _e('Select Image'); ?></th>
  <td><form enctype="multipart/form-data" id="upload-form" method="post" action="">
! 	<p>
! 		<label for="upload"><?php _e( 'Choose an image from your computer:' ); ?></label><br />
! 		<input type="file" id="upload" name="import" />
! 		<input type="hidden" name="action" value="save" />
! 		<?php wp_nonce_field( 'custom-background-upload', '_wpnonce-custom-background-upload' ); ?>
! 		<?php submit_button( __( 'Upload' ), 'button', 'submit', false ); ?>
! 	</p>
! 	<?php
! 		$image_library_url = get_upload_iframe_src( 'image', null, 'library' );
! 		$image_library_url = remove_query_arg( 'TB_iframe', $image_library_url );
! 		$image_library_url = add_query_arg( array( 'context' => 'custom-background', 'TB_iframe' => 1 ), $image_library_url );
! 	?>
! 	<p>
! 		<label for="choose-from-library-link"><?php _e( 'Or choose an image from your media library:' ); ?></label><br />
! 		<a id="choose-from-library-link" class="button thickbox" href="<?php echo esc_url( $image_library_url ); ?>"><?php _e( 'Choose Image' ); ?></a>
! 	</p>
! 	</form>
  </td>
  </tr>
  </tbody>
***************
*** 302,310 ****
  <tr valign="top">
  <th scope="row"><?php _e( 'Background Color' ); ?></th>
  <td><fieldset><legend class="screen-reader-text"><span><?php _e( 'Background Color' ); ?></span></legend>
! <?php $show_clear = get_background_color() ? '' : ' style="display:none"'; ?>
  <input type="text" name="background-color" id="background-color" value="#<?php echo esc_attr(get_background_color()) ?>" />
! <a class="hide-if-no-js" href="#" id="pickcolor"><?php _e('Select a Color'); ?></a> <span<?php echo $show_clear; ?> class="hide-if-no-js" id="clearcolor"> (<a href="#"><?php _e( 'Clear' ); ?></a>)</span>
  <div id="colorPickerDiv" style="z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;"></div>
  </fieldset></td>
  </tr>
--- 327,336 ----
  <tr valign="top">
  <th scope="row"><?php _e( 'Background Color' ); ?></th>
  <td><fieldset><legend class="screen-reader-text"><span><?php _e( 'Background Color' ); ?></span></legend>
! <?php $show_clear = get_theme_mod('background_color') ? '' : ' style="display:none"'; ?>
  <input type="text" name="background-color" id="background-color" value="#<?php echo esc_attr(get_background_color()) ?>" />
! <a class="hide-if-no-js" href="#" id="pickcolor"><?php _e('Select a Color'); ?></a> <span<?php echo $show_clear; ?> class="hide-if-no-js" id="clearcolor"> (<a href="#"><?php current_theme_supports( 'custom-background', 'default-color' ) ? _e( 'Default' ) : _e( 'Clear' ); ?></a>)</span>
! <input type="hidden" id="defaultcolor" value="<?php if ( current_theme_supports( 'custom-background', 'default-color' ) ) echo '#' . esc_attr( get_theme_support( 'custom-background', 'default-color' ) ); ?>" />
  <div id="colorPickerDiv" style="z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;"></div>
  </fieldset></td>
  </tr>
***************
*** 357,370 ****
  		wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $file ) );
  		update_post_meta( $id, '_wp_attachment_is_custom_background', get_option('stylesheet' ) );
  
! 		set_theme_mod('background_image', esc_url($url));
  
  		$thumbnail = wp_get_attachment_image_src( $id, 'thumbnail' );
! 		set_theme_mod('background_image_thumb', esc_url( $thumbnail[0] ) );
  
  		do_action('wp_create_file_in_uploads', $file, $id); // For replication
  		$this->updated = true;
  	}
  
  }
- ?>
--- 383,432 ----
  		wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $file ) );
  		update_post_meta( $id, '_wp_attachment_is_custom_background', get_option('stylesheet' ) );
  
! 		set_theme_mod('background_image', esc_url_raw($url));
  
  		$thumbnail = wp_get_attachment_image_src( $id, 'thumbnail' );
! 		set_theme_mod('background_image_thumb', esc_url_raw( $thumbnail[0] ) );
  
  		do_action('wp_create_file_in_uploads', $file, $id); // For replication
  		$this->updated = true;
  	}
  
+ 	/**
+ 	 * Replace default attachment actions with "Set as background" link.
+ 	 *
+ 	 * @since 3.4.0
+ 	 */
+ 	function attachment_fields_to_edit( $form_fields, $post ) {
+ 		$form_fields = array( 'image-size' => $form_fields['image-size'] );
+ 		$form_fields['buttons'] = array( 'tr' => '<tr class="submit"><td></td><td><a data-attachment-id="' . $post->ID . '" class="wp-set-background">' . __( 'Set as background' ) . '</a></td></tr>' );
+ 		$form_fields['context'] = array( 'input' => 'hidden', 'value' => 'custom-background' );
+ 
+ 		return $form_fields;
+ 	}
+ 
+ 	/**
+ 	 * Leave only "Media Library" tab in the uploader window.
+ 	 *
+ 	 * @since 3.4.0
+ 	 */
+ 	function filter_upload_tabs() {
+ 		return array( 'library' => __('Media Library') );
+ 	}
+ 
+ 	public function wp_set_background_image() {
+ 		if ( ! current_user_can('edit_theme_options') || ! isset( $_POST['attachment_id'] ) ) exit;
+ 		$attachment_id = absint($_POST['attachment_id']);
+ 		$sizes = array_keys(apply_filters( 'image_size_names_choose', array('thumbnail' => __('Thumbnail'), 'medium' => __('Medium'), 'large' => __('Large'), 'full' => __('Full Size')) ));
+ 		$size = 'thumbnail';
+ 		if ( in_array( $_POST['size'], $sizes ) )
+ 			$size = esc_attr( $_POST['size'] );
+ 
+ 		update_post_meta( $attachment_id, '_wp_attachment_is_custom_background', get_option('stylesheet' ) );
+ 		$url = wp_get_attachment_image_src( $attachment_id, $size );
+ 		$thumbnail = wp_get_attachment_image_src( $attachment_id, 'thumbnail' );
+ 		set_theme_mod( 'background_image', esc_url_raw( $url[0] ) );
+ 		set_theme_mod( 'background_image_thumb', esc_url_raw( $thumbnail[0] ) );
+ 		exit;
+ 	}
  }
